? np.sps
? npar.patch
? npar4.patch
? npar5.patch
? pspp-0.4.2.tar.gz
? pspp.list
? doc/.dirstamp
? doc/pspp.dvi
? lib/gsl-extras/.deps
? lib/gsl-extras/.dirstamp
? lib/gtksheet/.deps
? lib/gtksheet/.dirstamp
? lib/linreg/.deps
? lib/linreg/.dirstamp
? m4/Makefile.am
? m4/codeset.m4
? m4/gettext.m4
? m4/glibc2.m4
? m4/glibc21.m4
? m4/iconv.m4
? m4/intdiv0.m4
? m4/intmax.m4
? m4/inttypes-pri.m4
? m4/inttypes.m4
? m4/inttypes_h.m4
? m4/isc-posix.m4
? m4/lcmessage.m4
? m4/lib-ld.m4
? m4/lib-link.m4
? m4/lib-prefix.m4
? m4/longdouble.m4
? m4/longlong.m4
? m4/nls.m4
? m4/po.m4
? m4/printf-posix.m4
? m4/progtest.m4
? m4/signed.m4
? m4/size_max.m4
? m4/stdint_h.m4
? m4/uintmax_t.m4
? m4/ulonglong.m4
? m4/wchar_t.m4
? m4/wint_t.m4
? m4/xsize.m4
? po/remove-potcdate.sed
? src/data/.deps
? src/data/.dirstamp
? src/language/.deps
? src/language/.dirstamp
? src/language/control/.deps
? src/language/control/.dirstamp
? src/language/data-io/.deps
? src/language/data-io/.dirstamp
? src/language/data-io/file-handle.c
? src/language/data-io/list.c
? src/language/dictionary/.deps
? src/language/dictionary/.dirstamp
? src/language/expressions/.deps
? src/language/expressions/.dirstamp
? src/language/lexer/.deps
? src/language/lexer/.dirstamp
? src/language/lexer/q2c
? src/language/stats/.deps
? src/language/stats/.dirstamp
? src/language/stats/correlations.c
? src/language/stats/crosstabs.c
? src/language/stats/examine.c
? src/language/stats/frequencies.c
? src/language/stats/means.c
? src/language/stats/npar.c
? src/language/stats/oneway.c
? src/language/stats/rank.c
? src/language/stats/regression.c
? src/language/stats/t-test.c
? src/language/tests/.deps
? src/language/tests/.dirstamp
? src/language/utilities/.deps
? src/language/utilities/.dirstamp
? src/language/utilities/set.c
? src/language/xforms/.deps
? src/language/xforms/.dirstamp
? src/libpspp/.deps
? src/libpspp/.dirstamp
? src/libpspp/version.c
? src/math/.deps
? src/math/.dirstamp
? src/math/linreg/.deps
? src/math/linreg/.dirstamp
? src/math/ts/.deps
? src/math/ts/.dirstamp
? src/output/.deps
? src/output/.dirstamp
? src/output/charts/.deps
? src/output/charts/.dirstamp
? src/ui/.deps
? src/ui/.dirstamp
? src/ui/gui/.deps
? src/ui/gui/.dirstamp
? src/ui/gui/psppire
? src/ui/terminal/.deps
? src/ui/terminal/.dirstamp
? src/ui/terminal/pspp
? tests/formats/.deps
? tests/formats/.dirstamp
? tests/formats/inexactify
? tests/libpspp/.deps
? tests/libpspp/.dirstamp
? tests/libpspp/ll-test
? tests/libpspp/llx-test
Index: src/data/casefilter.c
===================================================================
RCS file: /sources/pspp/pspp/src/data/casefilter.c,v
retrieving revision 1.5
diff -b -w -U3 -r1.5 casefilter.c
--- src/data/casefilter.c	16 Dec 2006 04:26:42 -0000	1.5
+++ src/data/casefilter.c	19 Dec 2006 11:45:25 -0000
@@ -97,7 +97,7 @@
    filter considers. N_VARS is the size of VARS */
 void
 casefilter_add_variables (struct casefilter *filter,
-			   struct variable **vars, int n_vars)
+			  struct variable *const *vars, int n_vars)
 {
   int i;
 
@@ -117,5 +117,3 @@
   free (filter->vars);
   free (filter);
 }
-
-
Index: src/data/casefilter.h
===================================================================
RCS file: /sources/pspp/pspp/src/data/casefilter.h,v
retrieving revision 1.2
diff -b -w -U3 -r1.2 casefilter.h
--- src/data/casefilter.h	16 Dec 2006 04:26:42 -0000	1.2
+++ src/data/casefilter.h	19 Dec 2006 11:45:25 -0000
@@ -35,7 +35,8 @@
 
 /* Add the variables in VARS to the list of variables for which the
    filter considers. N_VARS is the size of VARS */
-void casefilter_add_variables (struct casefilter *, struct variable **, int);
+void casefilter_add_variables (struct casefilter *, 
+			       struct variable *const*, int);
 
 /* Destroy the filter FILTER */
 void casefilter_destroy (struct casefilter *); 
@@ -43,7 +44,10 @@
 /* Returns true iff the entire case should be skipped */
 bool casefilter_skip_case (const struct casefilter *, const struct ccase *);
 
-/* Returns true iff the variable V in case C is missing */
+/* Returns true iff the variable V in case C is missing.
+   Note that this function's behaviour is independent of the set of 
+   variables  contained by the filter.
+ */
 bool casefilter_variable_missing (const struct casefilter *f, 
 				   const struct ccase *c, 
 				   const struct variable *v);
Index: src/data/variable.c
===================================================================
RCS file: /sources/pspp/pspp/src/data/variable.c,v
retrieving revision 1.19
diff -b -w -U3 -r1.19 variable.c
--- src/data/variable.c	16 Dec 2006 03:40:41 -0000	1.19
+++ src/data/variable.c	19 Dec 2006 11:45:26 -0000
@@ -64,10 +64,9 @@
     struct vardict_info vardict;    
 
     /* Short name, used only for system and portable file input
-       and output.  Upper case only.  There is no index for short
-       names.  Short names are not necessarily unique.  Any
-       variable may have no short name, indicated by an empty
-       string. */
+       and output.  Upper case only. Short names are not necessarily
+       unique.  Any variable may have no short name, indicated by an
+       empty string. */
     char short_name[SHORT_NAME_LEN + 1];
 
     /* Each command may use these fields as needed. */
Index: src/language/command.def
===================================================================
RCS file: /sources/pspp/pspp/src/language/command.def,v
retrieving revision 1.11
diff -b -w -U3 -r1.11 command.def
--- src/language/command.def	15 Dec 2006 00:16:02 -0000	1.11
+++ src/language/command.def	19 Dec 2006 11:45:26 -0000
@@ -106,6 +106,7 @@
 DEF_CMD (S_DATA, 0, "MATCH FILES", cmd_match_files)
 DEF_CMD (S_DATA, 0, "MEANS", cmd_means)
 DEF_CMD (S_DATA, 0, "MODIFY VARS", cmd_modify_vars)
+DEF_CMD (S_DATA, 0, "NPAR TESTS", cmd_npar_tests)
 DEF_CMD (S_DATA, 0, "ONEWAY", cmd_oneway)
 DEF_CMD (S_DATA, 0, "PEARSON CORRELATIONS", cmd_correlations)
 DEF_CMD (S_DATA, 0, "RANK", cmd_rank)
@@ -202,7 +203,6 @@
 UNIMPL_CMD ("NLR", "Non Linear Regression")
 UNIMPL_CMD ("NOMREG", "Multinomial logistic regression")
 UNIMPL_CMD ("NONPAR CORR", "Nonparametric correlation")
-UNIMPL_CMD ("NPAR TESTS", "Nonparametric tests")
 UNIMPL_CMD ("NUMBERED", "")
 UNIMPL_CMD ("OLAP CUBES", "On-line analytical processing")
 UNIMPL_CMD ("OMS", "Output management")
Index: src/language/stats/automake.mk
===================================================================
RCS file: /sources/pspp/pspp/src/language/stats/automake.mk,v
retrieving revision 1.5
diff -b -w -U3 -r1.5 automake.mk
--- src/language/stats/automake.mk	14 Dec 2006 10:45:20 -0000	1.5
+++ src/language/stats/automake.mk	19 Dec 2006 11:45:26 -0000
@@ -8,18 +8,29 @@
 	src/language/stats/examine.c \
 	src/language/stats/frequencies.c \
 	src/language/stats/means.c \
+	src/language/stats/npar.c \
 	src/language/stats/oneway.c \
 	src/language/stats/rank.c \
 	src/language/stats/regression.c \
 	src/language/stats/t-test.c
+
 language_stats_sources = \
 	src/language/stats/aggregate.c \
 	src/language/stats/autorecode.c \
+	src/language/stats/binomial.c \
+	src/language/stats/binomial.h \
+	src/language/stats/chisquare.c \
+	src/language/stats/chisquare.h \
 	src/language/stats/descriptives.c \
+	src/language/stats/npar.h \
 	src/language/stats/sort-cases.c \
 	src/language/stats/sort-criteria.c \
 	src/language/stats/sort-criteria.h \
 	src/language/stats/flip.c \
+	src/language/stats/freq.c \
+	src/language/stats/freq.h \
+	src/language/stats/npar-summary.c \
+	src/language/stats/npar-summary.h \
 	src/language/stats/regression-export.h \
 	$(src_language_stats_built_sources)
 
Index: src/language/stats/binomial.c
===================================================================
RCS file: src/language/stats/binomial.c
diff -N src/language/stats/binomial.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ src/language/stats/binomial.c	19 Dec 2006 11:45:26 -0000
@@ -0,0 +1,270 @@
+/* PSPP - computes sample statistics.
+   Copyright (C) 2006 Free Software Foundation, Inc.
+   Written by John Darrington <john@darrington.wattle.id.au>
+
+   This program is free software; you can redistribute it and/or
+   modify it under the terms of the GNU General Public License as
+   published by the Free Software Foundation; either version 2 of the
+   License, or (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+   02110-1301, USA. */
+
+#include <config.h>
+#include <libpspp/compiler.h>
+#include <output/table.h>
+#include <libpspp/alloc.h>
+
+#include <data/case.h>
+#include <data/casefile.h>
+#include <data/dictionary.h>
+#include <data/procedure.h>
+#include <data/variable.h>
+#include <data/value.h>
+#include <data/value-labels.h>
+#include <data/casefilter.h>
+
+#include <libpspp/message.h>
+#include <libpspp/assertion.h>
+
+#include "binomial.h"
+#include "freq.h"
+
+#include "gettext.h"
+#define _(msgid) gettext (msgid)
+
+#include <libpspp/misc.h>
+
+#include <gsl/gsl_cdf.h>
+#include <gsl/gsl_randist.h>
+#include <gsl-extras/gsl-extras.h>
+
+#include <minmax.h>
+
+#include <libpspp/hash.h>
+
+static double calculate_binomial_internal (double n1, double n2,
+					   double p);
+
+
+static void
+swap (double *i1, double *i2)
+{
+  double temp = *i1;
+  *i1 = *i2;
+  *i2 = temp;
+}
+
+static double
+calculate_binomial (double n1, double n2, double p)
+{
+  const double n = n1 + n2;
+  const bool test_reversed = (n1 / n > p ) ;
+  if ( test_reversed )
+    {
+      p = 1 - p ;
+      swap (&n1, &n2);
+    }
+
+  return calculate_binomial_internal (n1, n2, p);
+}
+
+static double
+calculate_binomial_internal (double n1, double n2, double p)
+{
+  /* SPSS Statistical Algorithms has completely different and WRONG 
+     advice here. */
+
+  double sig1tailed = gslextras_cdf_binomial_P (n1, n1 + n2, p);
+
+  if ( p == 0.5 )
+    return sig1tailed > 0.5 ? 1.0 :sig1tailed * 2.0;
+
+  return sig1tailed ;
+}
+
+static void
+do_binomial (const struct dictionary *dict,
+	     const struct casefile *cf,
+	     const struct binomial_test *bst,
+	     struct freq *cat1,
+	     struct freq *cat2,
+	     const struct casefilter *filter
+	     )
+{
+  bool warn = true;
+
+  const struct one_sample_test *ost = (const struct one_sample_test *) bst;
+  struct ccase c;
+  struct casereader *r = casefile_get_reader (cf, NULL);
+
+  while (casereader_read(r, &c))
+    {
+      int v;
+      double w =
+	dict_get_case_weight (dict, &c, &warn);
+
+      for (v = 0 ; v < ost->n_vars ; ++v )
+	{
+	  const struct variable *var = ost->vars[v];
+	  const union value *value = case_data (&c, var);
+
+	  if ( casefilter_variable_missing (filter, &c, var))
+	    break;
+
+	  if ( NULL == cat1[v].value )
+	    {
+	      cat1[v].value = value_dup (value, var_get_width (var));
+	      cat1[v].count = w;
+	    }
+	  else if ( 0 == compare_values (cat1[v].value, value,
+					 var_get_width (var)))
+	    cat1[v].count += w;
+	  else if ( NULL == cat2[v].value )
+	    {
+	      cat2[v].value = value_dup (value, var_get_width (var));
+	      cat2[v].count = w;
+	    }
+	  else if ( 0 == compare_values (cat2[v].value, value,
+					 var_get_width (var)))
+	    cat2[v].count += w;
+	  else if ( bst->category1 == SYSMIS)
+	    msg (ME, _("Variable %s is not dichotomous"), var_get_name (var));
+	}
+
+      case_destroy (&c);
+    }
+  casereader_destroy (r);
+}
+
+
+
+void
+binomial_execute (const struct dataset *ds,
+		  const struct casefile *cf,
+		  struct casefilter *filter,
+		  const struct npar_test *test)
+{
+  int v;
+  const struct binomial_test *bst = (const struct binomial_test *) test;
+  const struct one_sample_test *ost = (const struct one_sample_test*) test;
+
+  struct freq *cat1 = xzalloc (sizeof (*cat1) * ost->n_vars);
+  struct freq *cat2 = xzalloc (sizeof (*cat1) * ost->n_vars);
+  struct tab_table *table ;
+
+  assert ((bst->category1 == SYSMIS) == (bst->category2 == SYSMIS) );
+
+  if ( bst->category1 != SYSMIS )
+    {
+      union value v;
+      v.f = bst->category1;
+      cat1->value = value_dup (&v, 0);
+    }
+
+  if ( bst->category2 != SYSMIS )
+    {
+      union value v;
+      v.f = bst->category2;
+      cat2->value = value_dup (&v, 0);
+    }
+
+  do_binomial (dataset_dict(ds), cf, bst, cat1, cat2, filter);
+
+  table = tab_create (7, ost->n_vars * 3 + 1, 0);
+
+  tab_dim (table, tab_natural_dimensions);
+
+  tab_title (table, _("Binomial Test"));
+
+  tab_headers (table, 2, 0, 1, 0);
+
+  tab_box (table, TAL_1, TAL_1, -1, TAL_1,
+	   0, 0, table->nc - 1, tab_nr(table) - 1 );
+
+  for (v = 0 ; v < ost->n_vars; ++v)
+    {
+      double n_total, sig;
+      const struct variable *var = ost->vars[v];
+      tab_hline (table, TAL_1, 0, tab_nc (table) -1, 1 + v * 3);
+
+      /* Titles */
+      tab_text (table, 0, 1 + v * 3, TAB_LEFT,
+		var_to_string (var));
+
+      tab_text (table, 1, 1 + v * 3, TAB_LEFT,
+		_("Group1"));
+
+      tab_text (table, 1, 2 + v * 3, TAB_LEFT,
+		_("Group2"));
+
+      tab_text (table, 1, 3 + v * 3, TAB_LEFT,
+		_("Total"));
+
+      /* Test Prop */
+      tab_float (table, 5, 1 + v * 3, TAB_NONE, bst->p, 8, 3);
+
+      /* Category labels */
+      tab_text (table, 2, 1 + v * 3, TAB_NONE,
+		var_get_value_name (var, cat1[v].value));
+
+      tab_text (table, 2, 2 + v * 3, TAB_NONE,
+		var_get_value_name (var, cat2[v].value));
+
+      /* Observed N */
+      tab_float (table, 3, 1 + v * 3, TAB_NONE,
+		 cat1[v].count, 8, 0);
+
+      tab_float (table, 3, 2 + v * 3, TAB_NONE,
+		 cat2[v].count, 8, 0);
+
+      n_total = cat1[v].count + cat2[v].count;
+
+
+      tab_float (table, 3, 3 + v * 3, TAB_NONE,
+		 n_total, 8, 0);
+
+      /* Observed Proportions */
+
+      tab_float (table, 4, 1 + v * 3, TAB_NONE,
+		 cat1[v].count / n_total, 8, 3);
+
+      tab_float (table, 4, 2 + v * 3, TAB_NONE,
+		 cat2[v].count / n_total, 8, 3);
+
+      tab_float (table, 4, 3 + v * 3, TAB_NONE,
+		 (cat1[v].count + cat2[v].count) / n_total, 8, 2);
+
+
+      /* Significance */
+      sig = calculate_binomial (cat1[v].count, cat2[v].count,
+				       bst->p);
+
+      tab_float (table, 6, 1 + v * 3, TAB_NONE,
+		 sig, 8, 3);
+    }
+
+  tab_text (table,  2, 0,  TAB_CENTER, _("Category"));
+  tab_text (table,  3, 0,  TAB_CENTER, _("N"));
+  tab_text (table,  4, 0,  TAB_CENTER, _("Observed Prop."));
+  tab_text (table,  5, 0,  TAB_CENTER, _("Test Prop."));
+
+  tab_text (table,  6, 0,  TAB_CENTER | TAT_PRINTF,
+	    _("Exact Sig. (%d-tailed)"),
+	    bst->p == 0.5 ? 2: 1);
+
+  tab_vline (table, TAL_2, 2, 0, tab_nr (table) -1);
+
+  free (cat1);
+  free (cat2);
+
+  tab_submit (table);
+
+}
Index: src/language/stats/binomial.h
===================================================================
RCS file: src/language/stats/binomial.h
diff -N src/language/stats/binomial.h
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ src/language/stats/binomial.h	19 Dec 2006 11:45:26 -0000
@@ -0,0 +1,49 @@
+/* PSPP - computes sample statistics.
+   Copyright (C) 2006 Free Software Foundation, Inc.
+   Written by John Darrington <john@darrington.wattle.id.au>
+
+   This program is free software; you can redistribute it and/or
+   modify it under the terms of the GNU General Public License as
+   published by the Free Software Foundation; either version 2 of the
+   License, or (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+   02110-1301, USA. */
+
+#if !binomial_h
+#define binomial_h 1
+
+#include <config.h>
+#include <stddef.h>
+#include <stdbool.h>
+
+#include "npar.h"
+
+
+struct binomial_test
+{
+  struct one_sample_test parent;
+  double p;
+  double category1;
+  double category2;
+  double cutpoint;
+};
+
+
+struct casefile;
+struct dataset;
+
+
+void binomial_execute (const struct dataset *, 
+		       const struct casefile *, 
+		       struct casefilter *, 
+		       const struct npar_test *);
+
+#endif
Index: src/language/stats/chisquare.c
===================================================================
RCS file: src/language/stats/chisquare.c
diff -N src/language/stats/chisquare.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ src/language/stats/chisquare.c	19 Dec 2006 11:45:26 -0000
@@ -0,0 +1,497 @@
+/* PSPP - computes sample statistics.
+   Copyright (C) 2006 Free Software Foundation, Inc.
+   Written by John Darrington <john@darrington.wattle.id.au>
+
+   This program is free software; you can redistribute it and/or
+   modify it under the terms of the GNU General Public License as
+   published by the Free Software Foundation; either version 2 of the
+   License, or (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+   02110-1301, USA. */
+
+#include <config.h>
+#include <libpspp/compiler.h>
+#include <libpspp/assertion.h>
+
+#include <stdlib.h>
+
+#include <data/case.h>
+#include <data/casefile.h>
+#include <data/casefilter.h>
+#include <data/variable.h>
+#include <data/dictionary.h>
+#include <data/procedure.h>
+
+#include <libpspp/message.h>
+#include <libpspp/hash.h>
+#include <libpspp/alloc.h>
+
+#include <gsl/gsl_cdf.h>
+
+#include <output/table.h>
+#include <data/value-labels.h>
+
+#include "npar.h"
+#include "chisquare.h"
+#include "freq.h"
+
+#include <math.h>
+
+#include "gettext.h"
+#define _(msgid) gettext (msgid)
+
+
+
+
+/* Return a hash table containing the frequency counts of each 
+   value of VAR in CF .
+   It is the caller's responsibility to free the hash table when 
+   no longer required.
+*/
+static struct hsh_table *
+create_freq_hash_with_range (const struct dictionary *dict, 
+			     const struct casefile *cf, 
+			     struct casefilter *filter,
+			     const struct variable *var, 
+			     double lo, 
+			     double hi)
+{
+  bool warn = true;
+  float i_d;
+  struct ccase c;
+  struct casereader *r = casefile_get_reader (cf, filter);
+
+  struct hsh_table *freq_hash = 
+    hsh_create (4, compare_freq, hash_freq, 
+		free_freq_mutable_hash,
+		(void *) var);
+
+  /* Populate the hash with zero entries */
+  for (i_d = trunc (lo); i_d <= trunc (hi); i_d += 1.0 ) 
+    {
+      union value the_value;
+      struct freq_mutable *fr = xmalloc (sizeof (*fr));
+
+      the_value.f = i_d;
+
+      fr->value = value_dup (&the_value, 0);
+      fr->count = 0;
+
+      hsh_insert (freq_hash, fr);
+    }
+
+  while (casereader_read(r, &c))
+    {
+      union value obs_value;
+      struct freq **existing_fr;
+      struct freq *fr = xmalloc(sizeof  (*fr));
+      fr->value = case_data (&c, var);
+
+      if ( casefilter_variable_missing (filter, &c, var))
+	{
+	  free (fr);
+	  continue;
+	}
+
+      fr->count = dict_get_case_weight (dict, &c, &warn);
+
+      obs_value.f = trunc (fr->value->f);
+
+      if ( obs_value.f < lo || obs_value.f > hi) 
+	{
+	  free (fr);
+	  case_destroy (&c);
+	  continue;
+	}
+
+      fr->value = &obs_value;
+
+      existing_fr = (struct freq **) hsh_probe (freq_hash, fr);
+
+      /* This must exist in the hash, because we previously populated it 
+	 with zero counts */
+      assert (*existing_fr);
+
+      (*existing_fr)->count += fr->count;
+      free (fr);
+
+      case_destroy (&c);
+    }
+  casereader_destroy (r);
+
+  return freq_hash;
+}
+
+
+/* Return a hash table containing the frequency counts of each 
+   value of VAR in CF .
+   It is the caller's responsibility to free the hash table when 
+   no longer required.
+*/
+static struct hsh_table *
+create_freq_hash (const struct dictionary *dict, 
+		  const struct casefile *cf, 
+		  struct casefilter *filter, 
+		  const struct variable *var)
+{
+  bool warn = true;
+  struct ccase c;
+  struct casereader *r = casefile_get_reader (cf, filter);
+
+  struct hsh_table *freq_hash = 
+    hsh_create (4, compare_freq, hash_freq, 
+		free_freq_hash,
+		(void *) var);
+
+  while (casereader_read(r, &c))
+    {
+      struct freq **existing_fr;
+      struct freq *fr = xmalloc(sizeof  (*fr));
+      fr->value = case_data (&c, var );
+
+      if ( casefilter_variable_missing (filter, &c, var))
+	{
+	  free (fr);
+	  continue;
+	}
+
+      fr->count = dict_get_case_weight (dict, &c, &warn);
+
+      existing_fr = (struct freq **) hsh_probe (freq_hash, fr);
+      if ( *existing_fr) 
+	{
+	  (*existing_fr)->count += fr->count;
+	  free (fr);
+	}
+      else
+	{
+	  *existing_fr = fr;
+	}
+
+      case_destroy (&c);
+    }
+  casereader_destroy (r);
+
+  return freq_hash;
+}
+
+
+
+static struct tab_table *
+create_variable_frequency_table (const struct dictionary *dict, 
+				 const struct casefile *cf, 
+				 struct casefilter *filter,
+				 const struct chisquare_test *test, 
+				 int v, 
+				 struct hsh_table **freq_hash)
+
+{
+  int i;
+  const struct one_sample_test *ost = (const struct one_sample_test*)test;
+  int n_cells;
+  struct tab_table *table ;
+  const struct variable *var =  ost->vars[v];
+
+  *freq_hash = create_freq_hash (dict, cf, filter, var);
+      
+  n_cells = hsh_count (*freq_hash);
+
+  if ( test->n_expected > 0 && n_cells != test->n_expected ) 
+    {
+      msg(ME, _("CHISQUARE test specified %d expected values, but"
+		" %d distinct values were encountered in variable %s."), 
+	  test->n_expected, n_cells, 
+	  var_get_name (var)
+	  );
+      return NULL;
+    }
+
+  table = tab_create(4, n_cells + 2, 0);
+  tab_dim (table, tab_natural_dimensions);
+
+  tab_title (table, var_to_string(var));
+  tab_text (table, 1, 0, TAB_LEFT, _("Observed N"));
+  tab_text (table, 2, 0, TAB_LEFT, _("Expected N"));
+  tab_text (table, 3, 0, TAB_LEFT, _("Residual"));
+	
+  tab_headers (table, 1, 0, 1, 0);
+
+  tab_box (table, TAL_1, TAL_1, -1, -1, 
+	   0, 0, table->nc - 1, tab_nr(table) - 1 );
+
+  tab_hline (table, TAL_1, 0, tab_nc(table) - 1, 1);
+
+  tab_vline (table, TAL_2, 1, 0, tab_nr(table) - 1);
+  for ( i = 2 ; i < 4 ; ++i ) 
+    tab_vline (table, TAL_1, i, 0, tab_nr(table) - 1);
+
+
+  tab_text (table, 0, table->nr - 1, TAB_LEFT, _("Total"));
+
+  return table;
+}
+
+
+static struct tab_table *
+create_combo_frequency_table (const struct chisquare_test *test)
+{
+  int i;
+  const struct one_sample_test *ost = (const struct one_sample_test*)test;
+
+  struct tab_table *table ;
+
+  int n_cells = test->hi - test->lo + 1;
+
+  table = tab_create(1 + ost->n_vars * 4, n_cells + 3, 0);
+  tab_dim (table, tab_natural_dimensions);
+
+  tab_title (table, _("Frequencies"));
+  for ( i = 0 ; i < ost->n_vars ; ++i ) 
+    {
+      const struct variable *var = ost->vars[i];
+      tab_text (table, i * 4 + 1, 1, TAB_LEFT, _("Category"));
+      tab_text (table, i * 4 + 2, 1, TAB_LEFT, _("Observed N"));
+      tab_text (table, i * 4 + 3, 1, TAB_LEFT, _("Expected N"));
+      tab_text (table, i * 4 + 4, 1, TAB_LEFT, _("Residual"));
+
+      tab_vline (table, TAL_2, i * 4 + 1, 
+		 0, tab_nr (table) - 1);
+
+      tab_vline (table, TAL_1, i * 4 + 2, 
+		 0, tab_nr (table) - 1);
+
+      tab_vline (table, TAL_1, i * 4 + 3, 
+		 1, tab_nr (table) - 1);
+
+      tab_vline (table, TAL_1, i * 4 + 4, 
+		 1, tab_nr (table) - 1);
+
+
+      tab_joint_text (table, 
+		      i * 4 + 1, 0,
+		      i * 4 + 4, 0,
+		      TAB_CENTER, 
+		      var_to_string (var));
+    }
+
+  for ( i = test->lo ; i <= test->hi ; ++i ) 
+    tab_float (table, 0, 2 + i - test->lo, 
+	       TAB_LEFT, 1 + i - test->lo, 8, 0);
+	
+  tab_headers (table, 1, 0, 2, 0);
+
+  tab_box (table, TAL_1, TAL_1, -1, -1, 
+	   0, 0, table->nc - 1, tab_nr(table) - 1 );
+
+  tab_hline (table, TAL_1, 1, tab_nc(table) - 1, 1);
+  tab_hline (table, TAL_1, 0, tab_nc(table) - 1, 2);
+
+  tab_text (table, 0, table->nr - 1, TAB_LEFT, _("Total"));
+
+  return table;
+}
+
+
+static struct tab_table *
+create_stats_table (const struct chisquare_test *test)
+{
+  const struct one_sample_test *ost = (const struct one_sample_test*) test;
+  
+  struct tab_table *table = tab_create (1 + ost->n_vars, 4, 0);
+  tab_dim (table, tab_natural_dimensions);
+  tab_title (table, _("Test Statistics"));
+  tab_headers (table, 1, 0, 1, 0);
+
+  tab_box (table, TAL_1, TAL_1, -1, -1,
+	   0, 0, tab_nc(table) - 1, tab_nr(table) - 1 );
+
+  tab_box (table, -1, -1, -1, TAL_1,
+	   1, 0, tab_nc(table) - 1, tab_nr(table) - 1 );
+
+
+  tab_vline (table, TAL_2, 1, 0, tab_nr (table) - 1);
+  tab_hline (table, TAL_1, 0, tab_nc (table) - 1, 1);
+  
+
+  tab_text (table, 0, 1, TAB_LEFT, _("Chi-Square"));
+  tab_text (table, 0, 2, TAB_LEFT, _("df"));
+  tab_text (table, 0, 3, TAB_LEFT, _("Asymp. Sig."));
+
+  return table;
+}
+
+
+void 
+chisquare_execute (const struct dataset *ds,
+		   const struct casefile *cf, 
+		   struct casefilter *filter,
+		   const struct npar_test *test)
+{
+  const struct dictionary *dict = dataset_dict (ds);
+  int v, i;
+  struct one_sample_test *ost = (struct one_sample_test *) test;
+  struct chisquare_test *cst = (struct chisquare_test *) test;
+  struct tab_table *stats_table = create_stats_table (cst);
+  int n_cells = 0;
+  double total_expected = 0.0;
+
+  double *df = xzalloc (sizeof (*df) * ost->n_vars);
+  double *xsq = xzalloc (sizeof (*df) * ost->n_vars);
+  
+  for ( i = 0 ; i < cst->n_expected ; ++i ) 
+    total_expected += cst->expected[i];
+
+  if ( cst->ranged == false ) 
+    {
+      for ( v = 0 ; v < ost->n_vars ; ++v ) 
+	{
+	  double total_obs = 0.0;
+	  struct hsh_table *freq_hash = NULL;
+	  struct tab_table *freq_table = 
+	    create_variable_frequency_table(dict, cf, filter, cst, 
+					    v, &freq_hash);
+
+	  struct freq **ff = (struct freq **) hsh_sort (freq_hash);
+
+	  if ( NULL == freq_table ) 
+	    {
+	      hsh_destroy (freq_hash);
+	      continue;
+	    }
+
+	  n_cells = hsh_count (freq_hash);
+
+	  for ( i = 0 ; i < n_cells ; ++i ) 
+	    total_obs += ff[i]->count;
+
+	  xsq[v] = 0.0;
+	  for ( i = 0 ; i < n_cells ; ++i ) 
+	    {
+	      double exp;
+	      const union value *observed_value = ff[i]->value;
+
+	      /* The key */
+	      tab_text (freq_table, 0, i + 1, TAB_LEFT, 
+			var_get_value_name (ost->vars[v], observed_value));
+
+	      /* The observed N */
+	      tab_float (freq_table, 1, i + 1, TAB_NONE,
+			 ff[i]->count, 8, 0);
+
+	      if ( cst->n_expected > 0 )
+		exp = cst->expected[i] * total_obs / total_expected ; 
+	      else
+		exp = total_obs / (double) n_cells; 
+
+	      tab_float (freq_table, 2, i + 1, TAB_NONE,
+			 exp, 8, 2);
+
+	      /* The residual */
+	      tab_float (freq_table, 3, i + 1, TAB_NONE,
+			 ff[i]->count - exp, 8, 2);
+
+	      xsq[v] += (ff[i]->count - exp) * (ff[i]->count - exp) / exp;
+	    }
+
+	  df[v] = n_cells - 1.0;
+
+	  tab_float (freq_table, 1, i + 1, TAB_NONE,
+		     total_obs, 8, 0);
+
+	  tab_submit (freq_table);
+
+	  hsh_destroy (freq_hash);
+	}
+    }
+  else  /* ranged == true */
+    {
+      struct tab_table *freq_table = create_combo_frequency_table (cst);
+      
+      n_cells = cst->hi - cst->lo + 1;
+
+      for ( v = 0 ; v < ost->n_vars ; ++v ) 
+	{
+	  double total_obs = 0.0;
+	  struct hsh_table *freq_hash = 
+	    create_freq_hash_with_range (dict, cf, filter, ost->vars[v], 
+					 cst->lo, cst->hi);
+
+	  struct freq **ff = (struct freq **) hsh_sort (freq_hash);
+
+	  assert ( n_cells == hsh_count (freq_hash));
+
+	  for ( i = 0 ; i < hsh_count (freq_hash) ; ++i ) 
+	    total_obs += ff[i]->count;
+
+	  xsq[v] = 0.0;
+	  for ( i = 0 ; i < hsh_count (freq_hash) ; ++i ) 
+	    {
+	      double exp;
+
+	      const union value *observed_value = ff[i]->value;
+
+	      /* The key */
+	      tab_text  (freq_table, v * 4 + 1, i + 2 , TAB_LEFT, 
+			 var_get_value_name (ost->vars[v], observed_value));
+
+	      /* The observed N */
+	      tab_float (freq_table, v * 4 + 2, i + 2 , TAB_NONE,
+			 ff[i]->count, 8, 0);
+
+	      if ( cst->n_expected > 0 )
+		exp = cst->expected[i] * total_obs / total_expected ; 
+	      else
+		exp = total_obs / (double) hsh_count (freq_hash); 
+
+	      /* The expected N */
+	      tab_float (freq_table, v * 4 + 3, i + 2 , TAB_NONE,
+			 exp, 8, 2);
+
+	      /* The residual */
+	      tab_float (freq_table, v * 4 + 4, i + 2 , TAB_NONE,
+			 ff[i]->count - exp, 8, 2);
+
+	      xsq[v] += (ff[i]->count - exp) * (ff[i]->count - exp) / exp;
+	    }
+
+	  
+	  tab_float (freq_table, v * 4 + 2, tab_nr (freq_table) - 1, TAB_NONE,
+		     total_obs, 8, 0);
+	  
+	  df[v] = n_cells - 1.0;
+	  
+	  hsh_destroy (freq_hash);
+	}
+
+      tab_submit (freq_table);
+    }
+
+
+  /* Populate the summary statistics table */
+  for ( v = 0 ; v < ost->n_vars ; ++v ) 
+    {
+      const struct variable *var = ost->vars[v];
+
+      tab_text (stats_table, 1 + v, 0, TAB_CENTER, var_get_name (var));
+
+      tab_float (stats_table, 1 + v, 1, TAB_NONE, xsq[v], 8,3);
+      tab_float (stats_table, 1 + v, 2, TAB_NONE, df[v], 8,0);
+
+      tab_float (stats_table, 1 + v, 3, TAB_NONE, 
+		 gsl_cdf_chisq_Q (xsq[v], df[v]), 8,3);
+    }
+
+  free (xsq);
+  free (df);
+
+  tab_submit (stats_table);
+}
+
